#!/usr/bin/perl

use strict;

my $fichier = shift || die "Aucun fichier a coloriser !";

open(F,$fichier) or die "Lecture impossible de '$fichier' : !$\n";
my @F=<F>;
close F;

my $lang;
my $colorize=0;
my $tocolorize;
my $doc;

foreach my $l (@F){

	if ( $l =~ /\[lang=(.*)\]/ ){
		$lang=$1;
		$colorize=1;
	}
	elsif ( $l =~ /\[\/lang\]/ ){

		$tocolorize =~ s/&lt;/</g;
		$tocolorize =~ s/&gt;/>/g;
		$tocolorize =~ s/&amp;/&/g;

		# Pour faire un cat plutot qu'un echo qui lui
		# interprete les variables, ", ' ...
		open(TMP,">/tmp/tocolorize.tmp");
		print TMP $tocolorize;
		close TMP;

		my $srccolor = `cat /tmp/tocolorize.tmp | enscript -j -w html -E$lang --color -o - | grep -Ev "HTML|HEAD|BODY|TITLE|HR|H1|A NAME|PRE|genscript"` || die "Erreur dans la commande 'enscript': $!\n";
		
		# Suppression du premier retour chariot
		$srccolor = substr($srccolor,1,-1);
		$doc .= $srccolor;

		# Raz des variables
		$colorize=0;
		$lang="";
		$tocolorize="";
	}
	else{
		if ( $colorize ){
			$tocolorize .= $l;
		}
		else{ $doc .= $l }
	}
}

print $doc;
