#!/usr/bin/perl

# En entree: un fichier docbook
#
# -------------------------------

use strict;
use XML::Parser::PerlSAX;
use myHandler;

my $fichier = shift || die "Aucun fichier a analyser ! \n";

my $my_Handler = myHandler->new;

# Creation du parser
my $parser = XML::Parser::PerlSAX->new;

my @dochl=$parser->parse(
                Source => { SystemId => $fichier } ,
                Handler => $my_Handler ) ;

binmode(STDOUT,':utf8');
print @dochl;

# -------------------------------
